# 完美质数对

## 题目描述

一天小明和朋友比试猜数能力，他们共比试 $T$ 轮，每轮在屏幕上显示一个偶数 $n\ (n>2)$。

假设 $x,y$ 均为质数，$x \leq y$ 且 $x+y=n$，则称 $(x,y)$ 为偶数 $n$ 的一组质数对。如果哥德巴赫猜想为真，那么任意一个偶数 $n\ (n>2)$ 至少有一组质数对。在所有 $n$ 的质数对中 $x,y$ 两数最接近的质数对 $(x,y)$ 被叫作“完美质数对”。

请你帮小明快速地算出每个 $n$ 的“完美质数对”。

## 输入格式

第一行一个整数 $T$

接下来的 $T$ 行，每行一个整数 $n$

## 输出格式

共 $T$ 行，每行两个质数 $x,y\ (x<y)$

## 样例 #1

### 样例输入 #1

```
1
20
```

### 样例输出 #1

```
7 13
```

## 样例 #2

### 样例输入 #2

```
2
56
78
```

### 样例输出 #2

```
19 37
37 41
```

## 提示

### 样例解释

对于样例 $1$，$n=20$，所有质数对有 $(3,17), (7,13)$，质数对中质数差分别为 $14,6$，因此 $(7,13)$ 是“完美质数对”

### 数据范围

本题采用捆绑测试，必须通过子任务中的所有测试点才能获得子任务对应分数。

子任务1（50pts）: $1\le T\le 10, 2<n\le 1000$

子任务2（40pts）: $1\le T\le 100, 2<n\le 10^4$

子任务3（10pts）: $1\le T\le 1000, 2<n\le 10^6$