add_rules("mode.release","mode.debug")
if is_mode("debug")then 
    add_defines("OIPRINT")
end 
set_warnings("all")

target("st_raw")
    set_kind("binary")
    add_files("day5/RMQ/st_raw.cpp")
    set_rundir("./day5/RMQ")

target("st_done")
    set_kind("binary")
    add_files("./day5/RMQ/st_done.cpp")

target("test")
    set_kind("binary")
    add_files("./test.cpp")
    add_tests("1",{files="./test.cpp",defines="OITEST",run_timeout=1000})

target("P3865")
    set_kind("binary")
    add_files("./day6/P3865/*.cpp")

target("binExp")
    set_kind("binary")
    add_files("./day6/binaryExponentiation/*.cpp")
    add_tests("binExp",{files="./day6/binaryExponentiation/*.cpp",defines = "ISTEST"})

target("fperfect")
    set_kind("binary")
    add_files("./day5/perfect/fix.cpp")
    set_rundir("./day5/perfect/")
    for val=1,4 do
        local s = tostring(val)
        add_tests(s,{files="./day5/perfect/fix.cpp",defines="OITEST",runargs={"perfect"..s..".in","perfect"..s..".ans"},run_timeout=1000})
    end 

target("pre88")
    set_kind("binary")
    add_files("./day6/pre88/*.cpp")

target("inverse")
    set_kind("binary")
    add_files("./day7/inverse/*.cpp")
    set_rundir("./day7/inverse")
    for v=1,2 do 
        local strname = tostring(v)
        add_tests(strname,{files="./day7/inverse/*.cpp",defines="OITEST",runargs=strname,run_timeout=1000})
    end

target("P5431")
    set_rundir("./day7/P5431")
    add_files("./day7/P5431/*.cpp")
    for v=1,1 do 
        local s=tostring(v)
        add_tests(s,{files="./day7/P5431/*.cpp",defines="OITEST",runargs={s..".in",s..".out"},run_timeout=1000})
    end 

target("segtree")
    set_rundir("./day7/SegmentTree")
    add_files("./day7/SegmentTree/*.cpp")
    for v=1,2 do 
        local s=tostring(v)
        add_tests(s,{files="./day7/SegmentTree/*.cpp",runargs={s..".in",s..".out"},defines="OITEST",run_timeout=1000})
    end 

target("P3372")
    set_rundir("./day7/P3372")
    add_files("./day7/P3372/*.cpp")
    for v=1,1 do
        local s=tostring(v)
        add_tests(s,{files="./day7/P3372/*.cpp",runargs={s..".in",s..".ans"},defines="OITEST",run_timeout=1000})
    end
    
target("T493931")
    set_rundir("./day8/T493931")
    add_files("./day8/T493931/*.cpp")
    for v=1,2 do 
        local s = tostring(v)
        add_tests(s,{files="./day8/T493931/*.cpp",runargs={s..".in",s..".ans"},defines="OITEST",run_timeout=1000})
    end 

target("U279656")
    set_rundir("./day8/U279656")
    add_files("./day8/U279656/*.cpp")
    for v=1,3 do
        local s=tostring(v)
        add_tests(s,{files="./day8/U279656/*.cpp",runargs={"seg"..s..".in","seg"..s..".ans"},defines="OITEST",run_timeout=1000})
    end